/*Includes ----------------------------------------------*/
#include "system.h"
#include "exception.h"
#include "hal_charge.h"
#include "app_flash.h"
#include "app_self_checking.h"
#include "hal_led.h"
#include "hal_mt.h"
#include "hal_ble_client.h"
#include "app_flash.h"
#include "app_pair_chargerpin.h"
#include "bsp_time.h"
#include "hal_scan_manage.h"
#include "ble_comm.h"
#include "bll_imu.h"

/*Private macro ------------------------------------------------*/
#define	SELF_CHECK_WHEEL_EMPTY_TIMES_MAX		MONITOR_SUSPEND_MODE_OVERFLOW_ERR_SUM_MAX			//ֿմ

#define SELF_CHECK_ITEM_SUCCESS							0																							//ԼĿɹ
#define SELF_CHECK_ITEM_FAIL								1	

//ԼĿʧ
enum{
	SELF_CHECK_ITEM_FRONT_SENSOR=0,																	//ԼĿ - ǰŴ
	SELF_CHECK_ITEM_BACK_SENSOR,																		//ԼĿ - Ŵ
	SELF_CHECK_ITEM_BATTERY,																				//ԼĿ - 
	SELF_CHECK_ITEM_CHARGE,																					//ԼĿ - ѹ
	SELF_CHECK_ITEM_ANT,																						//ԼĿ - 
	SELF_CHECK_ITEM_SUSPEND_MODE,																		//ԼĿ - 쳣		
	SELF_CHECK_ITEMS																					      //Լ	
};

#define SELF_CHECK_LED_DISPLAY_TIME					3000					  //Լʾʱ - msΪλ

#define SELF_CHECK_LED_TOGGLE_TIME					200						  //ԼƷתʱ - msΪλ

#define SELF_CHECK_SCAN_TRIGGER_TIMEOUT			10000						//ɨ败Լ쳬ʱʱ - msΪλ

#define SELF_CHECK_SET_IMU_TIMEOUT			    20000						//ȴIMUʼɹʱ

#define SELF_CHECK_SCAN_TARGET_ADV_NAME			"SH_SELF_CHECK"																//ɨ败Ŀ㲥

/*STRUCTION --------------------------------------------------
--*/
typedef enum {
	SELF_CHECK_STAGE_READY,																																	//׼׶
	SELF_CHECK_STAGE_CHECK,																																	//Լ׶
	
} SELF_CHECK_STAGE_e;
typedef enum{
	SELF_CHECK_LED_ON,																																			//Լ - 
	SELF_CHECK_LED_OFF,																																			//Լ - 
} SELF_CHECK_LED_SWITCH_e;
typedef struct self_check
{
	/*private member*/
	SELF_CHECK_STAGE_e				stage;																												//׶ֶ
	
	uint8_t										result[SELF_CHECK_ITEMS];																			//Լ
	
	uint8_t										item_fail_num;																								//ԼĿʧ
	
	SELF_CHECK_LED_SWITCH_e		led_switch;																										//Լƿ

	uint32_t									led_display_time;																							//Լʾʱ
	
	uint32_t									led_toggle_time;																							//ԼƷתʱ
	
	uint32_t									scan_trigger_timeout;																					//ɨ败Լ쳬ʱʱ
	
	bool											is_scan_success;																							//Ƿҵ㲥

} Self_Check_t;

/*Local Variable -----------------------------------------------*/
static Self_Check_t ob_self_check;

/*Local Functions ----------------------------------------------*/
static void clear_all_except(void)
{
	Except_ClearExceptype(EXCEPT_DATA_BACK_MAG);
	Except_ClearExceptype(EXCEPT_DATA_FRONT_ACC);
	Except_ClearExceptype(EXCEPT_DATA_FRONT_GRY);
	Except_ClearExceptype(EXCEPT_DATA_FRONT_MAG);
	Except_ClearExceptype(EXCEPT_DATA_CHARGE);
	Except_ClearExceptype(EXCEPT_DATA_BATTERY);
	Except_ClearExceptype(EXCEPT_IMU_SUSPEND_OVERFLOW);
	Except_ClearExceptype(EXCEPT_ANT_DAMAGE);
}

static void selft_scan_cb(void)
{
	ob_self_check.is_scan_success = true;
}

static scan_reslt_t scan_reslt_handle ={
	.handle = selft_scan_cb,
	.scanname =SELF_CHECK_SCAN_TARGET_ADV_NAME,
};

//static pair_reslt_t UartPair_result ={
//	.flag = 0,
//};

static void app_self_check_getreslut(){
	  uint8_t i=0;
		/*ȡԼǰ---------------------------------------------------------------------*/
	  for(i=0;i<SELF_CHECK_ITEMS;i++)ob_self_check.result[i] = SELF_CHECK_ITEM_SUCCESS;
		ob_self_check.item_fail_num = 0;

		/*ȡԼ---------------------------------------------------------------------*/
		
		//Լ - 쳣
		if(Except_IsError(EXCEPT_IMU_SUSPEND_OVERFLOW)){ob_self_check.result[SELF_CHECK_ITEM_SUSPEND_MODE] = SELF_CHECK_ITEM_FAIL;ob_self_check.item_fail_num = SELF_CHECK_ITEM_SUSPEND_MODE + 1;}	
		//Լ - ǰŴ
		if(Except_IsError(EXCEPT_DATA_FRONT_ACC)){ob_self_check.result[SELF_CHECK_ITEM_FRONT_SENSOR] = SELF_CHECK_ITEM_FAIL;}
		if(Except_IsError(EXCEPT_DATA_FRONT_GRY)){ob_self_check.result[SELF_CHECK_ITEM_FRONT_SENSOR] = SELF_CHECK_ITEM_FAIL;}
		if(Except_IsError(EXCEPT_DATA_FRONT_MAG)){ob_self_check.result[SELF_CHECK_ITEM_FRONT_SENSOR] = SELF_CHECK_ITEM_FAIL;}
		if(Except_IsError(EXCEPT_DATA_FRONT_ACC) || Except_IsError(EXCEPT_DATA_FRONT_GRY) || Except_IsError(EXCEPT_DATA_FRONT_MAG)){ob_self_check.item_fail_num = SELF_CHECK_ITEM_FRONT_SENSOR + 1;}
		//Լ - Ŵ
		if(Except_IsError(EXCEPT_DATA_BACK_MAG)){ob_self_check.result[SELF_CHECK_ITEM_BACK_SENSOR] = SELF_CHECK_ITEM_FAIL;ob_self_check.item_fail_num = SELF_CHECK_ITEM_BACK_SENSOR + 1;}
		//Լ - 
		if(Except_IsError(EXCEPT_DATA_BATTERY)){ob_self_check.result[SELF_CHECK_ITEM_BATTERY] = SELF_CHECK_ITEM_FAIL;ob_self_check.item_fail_num = SELF_CHECK_ITEM_BATTERY + 1;}
		//Լ - ѹ
		if(Except_IsError(EXCEPT_DATA_CHARGE)){ob_self_check.result[SELF_CHECK_ITEM_CHARGE] = SELF_CHECK_ITEM_FAIL;ob_self_check.item_fail_num = SELF_CHECK_ITEM_CHARGE+ 1;}
		//Լ - 
		if(Except_IsError(EXCEPT_ANT_DAMAGE)){ob_self_check.result[SELF_CHECK_ITEM_ANT] = SELF_CHECK_ITEM_FAIL;ob_self_check.item_fail_num = SELF_CHECK_ITEM_ANT + 1;}					
		
		//Լʾʱͷתʱ
		if(ob_self_check.item_fail_num != 0){
			ob_self_check.led_switch = SELF_CHECK_LED_ON;
			ob_self_check.led_display_time = TIME_GetTicks();
			ob_self_check.led_toggle_time = TIME_GetTicks();
		}else{
			ob_self_check.led_switch = SELF_CHECK_LED_ON;
//			if(UartPair_result.flag){
//				LED_Start(LED_SELF_CHECK,COLOR_BLUE);
//			}
//			else{
//				LED_Start(LED_SELF_CHECK,COLOR_CYAN);
//			}
		}
}

//Լģʽ
static const bll_imu_one_way_param_t selfcheck_front_param={
	.acc_power_mode 						= FML_IMU_ACC_POWER_MODE_NORMAL,						//ǰ - ٶģʽ
	.gry_power_mode 						= FML_IMU_GRY_POWER_MODE_NORMAL,						//ǰ - ģʽ
	.timestamp_resolution 			= FML_IMU_TIMESTAMP_25US,										//ǰ - ʱ25US
	.timestamp_switch 					= FML_IMU_TIMESTAMP_ON,											//ǰ - ʱ
	.acc_fs 										= FML_IMU_ACC_FS_16G,												//ǰ - ٶ - 16G
	.gry_fs 										= FML_IMU_GRY_FS_2000DPS,										//ǰ -  - 2000DPS
	.mag_fs 										= FML_IMU_MAG_FS_30GS,											//ǰ - شż - 30GS
	.acc_odr 									  = FML_IMU_ACC_ODR_104HZ,										//ǰ - ٶȲƵ - 104HZ
	.gry_odr 									  = FML_IMU_GRY_ODR_104HZ,										//ǰ - ǲƵ - 104HZ
	.mag_odr 									  = FML_IMU_MAG_ODR_200HZ,										//ǰ - شżƲƵ - 200HZ
	.fifo_odr 									= FML_IMU_FIFO_ODR_104HZ,	
};

static const bll_imu_one_way_param_t selfcheck_back_param={
	.acc_power_mode 						= FML_IMU_ACC_POWER_MODE_NORMAL,						// - ٶģʽ
	.gry_power_mode 						= FML_IMU_GRY_POWER_MODE_NORMAL,						// - ģʽ
	.timestamp_resolution 			= FML_IMU_TIMESTAMP_25US,										// - ʱ25US
	.timestamp_switch 					= FML_IMU_TIMESTAMP_OFF,										// - ʱر
	.acc_fs 										= FML_IMU_ACC_FS_16G,											  // - ٶ - 16G
	.gry_fs 										= FML_IMU_GRY_FS_2000DPS,										// -  - 2000DPS
	.mag_fs 										= FML_IMU_MAG_FS_30GS,											// - شż - 30GS
	.acc_odr 										= FML_IMU_ACC_ODR_OFF,											// - ٶȲƵ - ر
	.gry_odr 										= FML_IMU_GRY_ODR_OFF,											// - ǲƵ - ر
	.mag_odr 										= FML_IMU_MAG_ODR_200HZ,										// - شżƲƵ - 200HZ
	.fifo_odr 									= FML_IMU_FIFO_ODR_OFF,	
};

static const bll_imu_param_t selfcheck_bll_imu_param_t={
	.config_param[FML_IMU_DIR_FRONT] = &selfcheck_front_param,
	.config_param[FML_IMU_DIR_BACK] =  &selfcheck_back_param,
};

static void ReadyIntoSelfMode(void){
		//ΪԼģʽתһ
		hal_ble_scan_result_Regist(&scan_reslt_handle);
		ob_self_check.is_scan_success 			= false;
		ob_self_check.scan_trigger_timeout 	= TIME_GetTicks();
	  ob_self_check.stage = SELF_CHECK_STAGE_READY;
		clear_all_except();	//쳣
		LED_Start(LED_SELF_CHECK,COLOR_BLACK); 
		LED_Stop(LED_SELF_CHECK);
		bll_imu_Resume_config_param(&selfcheck_bll_imu_param_t);
		
		memset(ob_self_check.result, SELF_CHECK_ITEM_SUCCESS, SELF_CHECK_ITEMS);	
//	  UartPair_result.flag =0;
//	  app_UartPair_Regist(&UartPair_result);
		DEBUG_LOG("app_self_checking_Process clear_all_except\r\n");
}


static void app_self_checking_Process(void)
{
	static uint8_t state =0;
	static uint8_t state_selft =0;
	static uint8_t displaycnt =0;
  uint8_t front_CS =0,back_CS =0;
	uint8_t imu_configcnt =0;
	
	switch(state){
		case 0:
			    if(BLE_CHARGE_DONE == hal_charge_Getstate() || \
						 BLE_CHARGE_INSERT == hal_charge_Getstate()
						){
							if(Except_IsErrorExist())																																														//ڴ
							{
								front_CS = bll_imu_query_config_param_is_ready(BLL_IMU_DIR_FRONT,&selfcheck_bll_imu_param_t);
							  back_CS  = bll_imu_query_config_param_is_ready(BLL_IMU_DIR_BACK,&selfcheck_bll_imu_param_t);
								if(BLL_IMU_CONFIG_FINISH == front_CS && BLL_IMU_CONFIG_FINISH == back_CS){																		//ǰԼ
									bll_imu_Resume_unregister_config_param(&selfcheck_bll_imu_param_t);//صԼ
								}
								else{																																																							//ǰԼ{
									ST_scan_start();
									ReadyIntoSelfMode();
									state =1;
									state_selft =0;
								}
							}
							else{
								ST_scan_start();//ΪԼģʽתһ
								ReadyIntoSelfMode();
								state =1;
								state_selft =0;
							}
					}
			    break;
    case 1:
					if(ob_self_check.is_scan_success == true)
					{
						ob_self_check.stage = SELF_CHECK_STAGE_CHECK;																				//Լ׶
						state =2;
						Process_SetHoldOn(app_self_checking_Process,1);
						DEBUG_LOG("ob_self_check.is_scan_success\r\n");
					}else{
             if((TIME_GetTicks() - ob_self_check.scan_trigger_timeout) > SELF_CHECK_SCAN_TRIGGER_TIMEOUT)		//ʱûɨ赽㲥
						 {
							  state = 2;
							  ob_self_check.is_scan_success 			= false;																					//ɨɹ־λ
							  state_selft =3;
							  hal_ble_scan_result_Clear(&scan_reslt_handle);																				//ֹɨ败
						    ST_scan_stop();
							  DEBUG_LOG("ob_self_check.scan_trigger_timeout\r\n");
						 }
					}
			    break;
		case 2:
			    if(BLE_CHARGE_PULLOUT == hal_charge_Getstate()){
						 state = 0;
//						 app_UartPair_Clear(&UartPair_result);
						 DEBUG_LOG("ob_self_check.scan BLE_Client_T_CHARGE_PULLOUT\r\n");
					}
			    break;
		default:
			    break;
	}
	
	switch(state_selft)
	{
		case 0:																															   
			  if(SELF_CHECK_STAGE_CHECK == ob_self_check.stage){//ɨɹ
					  MT_Run(500);
						bll_imu_Resume_config_param(&selfcheck_bll_imu_param_t);//Լģʽ
				    state_selft = 1;
					  imu_configcnt =0;
				}
				break;
		case 1:
			  if(BLE_CHARGE_PULLOUT == hal_charge_Getstate()){
					 state_selft = 3;
				}
			  else {
					  front_CS = bll_imu_query_config_param_is_ready(BLL_IMU_DIR_FRONT,&selfcheck_bll_imu_param_t);
						back_CS  = bll_imu_query_config_param_is_ready(BLL_IMU_DIR_BACK,&selfcheck_bll_imu_param_t);
						if(BLL_IMU_CONFIG_FINISH == front_CS && BLL_IMU_CONFIG_FINISH == back_CS){
							state_selft = 2;
							displaycnt =0;
							app_self_check_getreslut();
						}
						else if(BLL_IMU_CONFIG_DOING != front_CS || BLL_IMU_CONFIG_DOING != back_CS){
							bll_imu_Resume_config_param(&selfcheck_bll_imu_param_t);
							imu_configcnt++;
							DEBUG_LOG(">>>>>>222 out sleep mode,%d  %d\n",front_CS,back_CS);
							if(imu_configcnt > 20){imu_configcnt =0;
								 Except_SetExceptype(EXCEPT_DATA_FRONT_ACC);
								 Except_SetExceptype(EXCEPT_DATA_FRONT_GRY);
								 Except_SetExceptype(EXCEPT_DATA_FRONT_MAG);
								 Except_SetExceptype(EXCEPT_IMU_SUSPEND_OVERFLOW); 
								 state_selft = 2;
								 displaycnt =0;
							} 
						}
			  }
			  break;
	  case 2:
			   if(displaycnt < ob_self_check.item_fail_num){
						if(TIME_GetTicks() - ob_self_check.led_toggle_time >= SELF_CHECK_LED_TOGGLE_TIME){ob_self_check.led_toggle_time = TIME_GetTicks();
							if(ob_self_check.led_switch == SELF_CHECK_LED_ON){
								LED_Start(LED_SELF_CHECK,COLOR_LIGHRED);
								ob_self_check.led_switch = SELF_CHECK_LED_OFF;
							}
							else{
								LED_Start(LED_SELF_CHECK,COLOR_BLACK);
								ob_self_check.led_switch = SELF_CHECK_LED_ON;
								displaycnt++;
							}
						}
					}
				  else if(TIME_GetTicks() - ob_self_check.led_display_time >= SELF_CHECK_LED_DISPLAY_TIME){//ʾʱ䵽ˣֶȡԼʾ
						ob_self_check.led_display_time = TIME_GetTicks();
						displaycnt =0;
						app_self_check_getreslut();
					}
			    break;
		 case 3:
				 state_selft = 0;
		     ob_self_check.stage = SELF_CHECK_STAGE_READY;
         LED_Start(LED_SELF_CHECK,COLOR_BLACK); 
				 LED_Stop(LED_SELF_CHECK);
				 ob_self_check.led_switch = SELF_CHECK_LED_OFF;																					//ԼΪ
				 bll_imu_Resume_unregister_config_param(&selfcheck_bll_imu_param_t);//صԼ				
				 break;
		 default:
			   break;
	}	
}
//static void app_self_checking_printf_process(void)
//{
//	DEBUG_LOG("self_check: FRONT_SENSOR:%d BACK_SENSOR:%d BATTERY:%d CHARGE:%d ANT:%d suspend_mode:%d scan_trigger_timeout:%d\n", \
//	Except_IsError(EXCEPT_DATA_FRONT_ACC) || Except_IsError(EXCEPT_DATA_FRONT_GRY) || Except_IsError(EXCEPT_DATA_FRONT_MAG), \
//	Except_IsError(EXCEPT_DATA_BACK_MAG), \
//	Except_IsError(EXCEPT_DATA_BATTERY), \
//	Except_IsError(EXCEPT_DATA_CHARGE), \
//	Except_IsError(EXCEPT_ANT_DAMAGE), \
//	Except_IsError(EXCEPT_IMU_SUSPEND_OVERFLOW),ob_self_check.scan_trigger_timeout);
//}

/*API ----------------------------------------------------------*/
void app_self_checking_Init(void)
{
	ob_self_check.stage = SELF_CHECK_STAGE_READY;
	ob_self_check.item_fail_num = 0;
	ob_self_check.led_switch = SELF_CHECK_LED_OFF;
	ob_self_check.led_display_time = 0;
	ob_self_check.led_toggle_time = 0;
	ob_self_check.is_scan_success = false;																		
	ob_self_check.scan_trigger_timeout = SELF_CHECK_SCAN_TRIGGER_TIMEOUT;								

	Process_Start(10,"app_self_checking_Process",app_self_checking_Process);
  
//	Process_Start(1000,"app_self_checking_printf_process",app_self_checking_printf_process);
}

uint32_t app_self_checking_get_scan_trigger_timeout(void)
{
	return ob_self_check.scan_trigger_timeout;
}




















