#ifndef	__BSP_ADC_H__
#define __BSP_ADC_H__
/*********************************************************************
 * INCLUDES
 */
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"
#include "nrf_gpio.h"
#include "nrf_pwr_mgmt.h"
#include "nrf_drv_saadc.h"


/*********************************************************************
 * DEFINITIONS
 */
//ERROR CODE
#define ADC_OP_SUCCESS										0x00													//adcɹ
#define ADC_ERR_INIT_PIN									0x01													//ѳʼ
#define ADC_ERR_INIT_CHANNEL							0x02													//ͨѳʼ
#define ADC_ERR_INIT_CONGESTION						0x03													//Чͨȫʼ
#define ADC_ERR_REMOVE_PIN_CHANNEL				0x04													//Ƴͨʧ
#define ADC_ERR_READ_NO_CHANNEL						0x05													//ͨȡʧ
#define ADC_ERR_READ_TIMEOUT							0x06													//ȡadcʱ
#define ADC_ERR_READ_FAIL									0x07													//ȡadcʧ
#define ADC_ERR_READ_BUSY									0x08													//BUSYæµ

/*********************************************************************
 * STRUCTION
 */
typedef void (*bsp_adc_read_cb)(int16_t adc_value);
/*********************************************************************
 * API
 */
 
//ʼADCźͨ
uint32_t ADC_SetPinChannel(uint32_t pin, uint32_t channel,nrf_gpio_pin_pull_t pin_pull);
//ƳѳʼADCźͨ
uint32_t ADC_RemovePinChannel(uint32_t pin, uint32_t channel);
//ADCʼ
void ADC_Initialize(void);
//ADCȡ
uint32_t ADC_Read(uint32_t channel, int16_t *p_adc_value);
//ADCصȡ
uint32_t ADC_Read_CallBack_Once(uint32_t channel, bsp_adc_read_cb cb);
//ADCʼûΪDisableɶԳ
void ADC_Enable(void);
//ADC
void ADC_Disable(void);

uint32_t ADC_ReadChargePin(uint32_t channel);

uint8_t bsp_Get_ChargePinADC(int16_t *adc);

#endif
















