#ifndef __bsp_pwm_h__
#define __bsp_pwm_h__
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"
#include "nrf_drv_pwm.h"


/**************************************
DEFINECTION
*/


#define PWM_SEQUENCE_VALUES_LEN(seq_values)			NRF_PWM_VALUES_LENGTH(seq_values)						//SEQUENCE_VALUES_LEN

#define PWM_FLAG_STOP														NRF_DRV_PWM_FLAG_STOP												//PLAYBACK_MODE
#define PWM_FLAG_LOOP														NRF_DRV_PWM_FLAG_LOOP												//PLAYBACK_MODE
#define PWM_FLAG_SIGNAL_END_SEQ0								NRF_DRV_PWM_FLAG_SIGNAL_END_SEQ0   					//PLAYBACK_MODE     
#define PWM_FLAG_SIGNAL_END_SEQ1								NRF_DRV_PWM_FLAG_SIGNAL_END_SEQ1     				//PLAYBACK_MODE   
#define PWM_FLAG_NO_EVT_FINISHED								NRF_DRV_PWM_FLAG_NO_EVT_FINISHED      			//PLAYBACK_MODE  
#define PWM_FLAG_START_VIA_TASK									NRF_DRV_PWM_FLAG_START_VIA_TASK         		//PLAYBACK_MODE
/**************************************
STRUCTION
*/
typedef struct
{
    uint16_t channel_0; ///< Duty cycle value for channel 0.
    uint16_t channel_1; ///< Duty cycle value for channel 1.
    uint16_t channel_2; ///< Duty cycle value for channel 2.
    uint16_t channel_3; ///< Duty cycle value for channel 3.
} pwm_values_individual_t;

typedef uint16_t pwm_values_common_t;
/**************************************
API
*/
//PWMͨ
void SetPwm_Channels(uint32_t channel_1, uint32_t channel_2, uint32_t channel_3, uint32_t channel_4);
//PWMжϻص
void SetPwm_IRQ(nrfx_pwm_handler_t pwm_callback, uint8_t irq_priority);
//PWMĻʱ
void SetPwm_BaseClock(nrf_pwm_clk_t clock);
//PWMļģʽ
void SetPwm_CountMode(nrf_pwm_mode_t count_mode);
//PWMռձֵ
void SetPwm_DutyCycleThreshold(uint16_t Max_duty_cycle_value);
//PWMеƽģʽ,һcycleĽзʽ
void SetPwm_SequenceStepMode(nrf_pwm_dec_step_t step_mode);
//PWM ĳʼ
void Pwm_Initialize(void);
//PWM δʼ
void Pwm_UnInitialize(void);
//һͨ
nrf_pwm_sequence_t* Pwm_SetIndSequence(pwm_values_individual_t *p_seqValues, uint16_t seqValues_length,  uint32_t seqValues_repeats, uint32_t seqValues_end_delay);
//һͨ
nrf_pwm_sequence_t* Pwm_SetComSequence(pwm_values_common_t *p_seqValues, uint16_t seqValues_length,  uint32_t seqValues_repeats, uint32_t seqValues_end_delay);
//PWMָеĲ
uint32_t SetSimplePwmPlayBack(nrf_pwm_sequence_t *pwm_sequence, uint16_t playback_count, uint32_t flags);

#endif
