#ifndef __BSP_SPI_H__
#define __BSP_SPI_H__


//SPI 1.0V


/*********************************************************************
 * INCLUDES
 */
#include "nrf_drv_spi.h"
#include "nrf_gpio.h"
#include "nrf_pwr_mgmt.h"
#include <string.h>
#include "app_error.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"

/*********************************************************************
 * DEFINITIONS
 */
#define BOARD_SPI_CS_ON             0																	// SPIƬѡźſ
#define BOARD_SPI_CS_OFF            1																	// SPIƬѡźŹ

#define BOARD_SPI0_MISO_IO          PIN_FRONT_SPI_MISO								// SPI0IO
#define BOARD_SPI0_MOSI_IO          PIN_FRONT_SPI_MOSI								// SPI0IO
#define BOARD_SPI0_CLK_IO           PIN_FRONT_SPI_SCLK								// SPI0ʱӿIO

#define SPI0_CS_NUMBER							1																	// SPI0Ƭѡ
#define BOARD_SPI0_CS0_IO						PIN_FRONT_SPI_nCS									// SPI0Ƭѡ0źIO
#define SPI0_CS_LIST								{BOARD_SPI0_CS0_IO}								// SPI0Ƭѡб

#define BOARD_SPI1_MISO_IO          PIN_FLASH_SPI_MISO								// SPI1IO
#define BOARD_SPI1_MOSI_IO          PIN_FLASH_SPI_MOSI								// SPI1IO
#define BOARD_SPI1_CLK_IO           PIN_FLASH_SPI_SCLK								// SPI1ʱӿIO

#define SPI1_CS_NUMBER							1																	// SPI1Ƭѡ
#define BOARD_SPI1_CS0_IO						PIN_FLASH_SPI_nCS									// SPI1Ƭѡ0źIO
#define SPI1_CS_LIST								{BOARD_SPI1_CS0_IO}								// SPI1Ƭѡб

#define BOARD_SPI2_MISO_IO          0xFF															// SPI2IO
#define BOARD_SPI2_MOSI_IO          0xFF															// SPI2IO
#define BOARD_SPI2_CLK_IO           0xFF															// SPI2ʱӿIO

#define SPI2_CS_NUMBER							1																	// SPI2Ƭѡ
#define BOARD_SPI2_CS0_IO						0xFF															// SPI2Ƭѡ0źIO
#define SPI2_CS_LIST								{BOARD_SPI2_CS0_IO}								// SPI2Ƭѡб

#define SPI_INSTANCE_0  						0																	// SPI0 instance index 

#define SPI_INSTANCE_1  						1																	// SPI1 instance index 

#define SPI_INSTANCE_2  						2																	// SPI2 instance index 

#define SPI0_FREQUENCY							NRF_DRV_SPI_FREQ_8M								// SPI0 Ƶ

#define SPI1_FREQUENCY							NRF_DRV_SPI_FREQ_8M								// SPI1 Ƶ

#define SPI2_FREQUENCY							NRF_DRV_SPI_FREQ_8M								// SPI2 Ƶ

#define WAIT_TIME_VALUE							10000															// ȴʱֵ  - 1ms				8M-145ٽֵ

#define SPI_READ           					0x00															//־λ
#define SPI_WRITE										0x01															//д־λ


//ERROR CODE
#define SPI_OP_SUCCESS							0x00															// spiɹ
#define SPI_ERROR_TIMEOUT						(SPI_OP_SUCCESS+0x01)							// ʱ
#define SPI_ERROR_CS								(SPI_OP_SUCCESS+0x02)							// ƬѡŴ
#define SPI_ERROR_LENGTH						(SPI_OP_SUCCESS+0x03)							// ݳ̫

/*********************************************************************
 * API FUNCTIONS
 */
 
//SPI0ʼ
void 		 SPI0_Init(void);
//SPI0ֻĴ
uint32_t SPI0_OnlyReadReg(uint32_t CsPin_number, uint8_t reg_addr, uint8_t *pData, uint8_t DataLen);
//SPI0ֻдĴ
uint32_t SPI0_OnlyWriteReg(uint32_t CsPin_number, uint8_t reg_addr, uint8_t *pData, uint8_t DataLen);
//SPI0
uint32_t SPI0_Enable(void);
//SPI0ʵֵ͹SPI_Enableʹ
uint32_t SPI0_Disable(void);

//SPI1ʼ
void 		 SPI1_Init(void);
//SPI1ֻĴ
uint32_t SPI1_OnlyReadReg(uint32_t CsPin_number, uint8_t reg_addr, uint8_t *pData, uint8_t DataLen);
//SPI1ֻдĴ
uint32_t SPI1_OnlyWriteReg(uint32_t CsPin_number, uint8_t reg_addr, uint8_t *pData, uint8_t DataLen);
//SPI1
uint32_t SPI1_Enable(void);
//SPI1ʵֵ͹SPI_Enableʹ
uint32_t SPI1_Disable(void);

//SPI2ʼ
void 		 SPI2_Init(void);
//SPI2ֻĴ
uint32_t SPI2_OnlyReadReg(uint32_t CsPin_number, uint8_t reg_addr, uint8_t *pData, uint8_t DataLen);
//SPI2ֻдĴ
uint32_t SPI2_OnlyWriteReg(uint32_t CsPin_number, uint8_t reg_addr, uint8_t *pData, uint8_t DataLen);
//SPI2
uint32_t SPI2_Enable(void);
//SPI2ʵֵ͹SPI_Enableʹ
uint32_t SPI2_Disable(void);

#endif /* _BOARD_SPI_H_ */


