#ifndef __BLL_IMU_H__
#define __BLL_IMU_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"
#include "fml_imu.h"

/*Private macro ------------------------------------------------------------------------------------------------------------------------------------*/



/*STRUCTION ----------------------------------------------------*/
typedef fml_imu_param_t											bll_imu_one_way_param_t;
typedef fml_imu_data_t											bll_imu_data_t;
typedef fml_imu_data_notify_cb   						bll_imu_data_notify_cb;

typedef enum{
	
	BLL_IMU_DATA_NOTIFY_CB_PRIORITY_0					=	0,																						//ȼ - 0				ȼԽ󣬼Խ
	
	BLL_IMU_DATA_NOTIFY_CB_PRIORITY_1					= 1,																						//ȼ - 1				ȼԽ󣬼Խ
	
	BLL_IMU_DATA_NOTIFY_CB_PRIORITY_NUM																												//ȼ
	
} BLL_IMU_DATA_NOTIFY_CB_PRIORITY_e;

typedef enum{
	BLL_IMU_DIR_FRONT													=	FML_IMU_DIR_FRONT,														// - ǰ
	
	BLL_IMU_DIR_BACK													= FML_IMU_DIR_BACK,															// - 
	
	BLL_IMU_DIR_NUM														=	FML_IMU_DIR_NUM,															// - 
	
} BLL_IMU_DIR_e;

typedef struct
{
	const bll_imu_one_way_param_t										*config_param[FML_IMU_DIR_NUM];									//ò
} bll_imu_param_t;

typedef enum{
	BLL_IMU_CONFIG_FAIL=0x0,
	
	BLL_IMU_CONFIG_DOING=(1<<6),
	
	BLL_IMU_CONFIG_FINISH=(2<<6),
	
	BLL_IMU_CONFIG_VAILERROR=(3<<6),
	
} BLL_IMU_CONFIG_RESULT;


/*API -------------------------------------------------------*/
/**
	@brief 		ʼIMUҵ߼
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	bll_imu_Init(void);
/**
	@brief 		עIMUҪõĲ
	@param 		param							- [in]	IMUҪõĲַ
	@return 						- [out]	0ʧܣɹزַ
*/
const bll_imu_param_t* bll_imu_Resume_config_param(const bll_imu_param_t *param);

/**
	@brief 		עעIMUòIMU
	@param 		param							- [in]	IMUòĵַ
	@return 						- [out]	0ɹ-1ַ쳣-2ûиעIMUò
*/
int bll_imu_Resume_unregister_config_param(const bll_imu_param_t* param);

/**
	@brief 		עIMU֪ͨص
	@param 		priority 					- [in]	صȼ
	@param 		cb 								- [in]	ص
	@return 						- [out]	-1ʧܣ0ɹ
*/
int bll_imu_register_data_notify_callback(BLL_IMU_DATA_NOTIFY_CB_PRIORITY_e priority, bll_imu_data_notify_cb cb);
/**
	@brief 		ʼáעIMUɸѡȼãֻһΡ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int bll_imu_start_config(void);
/**
	@brief 		ѯIMUòǷ׼
	@param 		dir 							- [in]	
	@param 		param							- [in]	ҪѯIMUò
	@return 	ѯ					- [out] [7:6]״̬0ʧܣ1У2ɹ3ǰòСò򲻷ϣ						[0:5]ò.
*/
uint8_t bll_imu_query_config_param_is_ready(BLL_IMU_DIR_e dir, const bll_imu_param_t *param);
/**
	@brief 		ȡǰIMUݵ
	@param 		dir 							- [in]	
	@return 	صǰIMUݵ
*/
int bll_imu_get_data_num(BLL_IMU_DIR_e dir);
/**
	@brief 		ȡǰIMU
	@param 		dir 							- [in]	
	@param 		index 						- [in]	
	@param 		pdata 						- [out]	صIMUָ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int bll_imu_get_data(BLL_IMU_DIR_e dir, int index, bll_imu_data_t *pdata);
/**
	@brief 		رIMU
	@return 						- [out]	-1ʧܣ0ɹ
*/
int bll_imu_close(void);


#ifdef __cplusplus
}
#endif

#endif








