#ifndef __FML_IMU_H__
#define __FML_IMU_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"

/*Private macro ------------------------------------------------------------------------------------------------------------------------------------*/

#define	FML_IMU_CONFIG_FLOW_DONE						0xFFFFFFFF																			//ɱ־

/*STRUCTION ----------------------------------------------------*/
typedef enum{
	FML_IMU_ACC_ODR_OFF   										= 0,																						//رռٶ									ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_ACC_ODR_12HZ5 										= 1,																						//Ƶ - 12.5					ȼ - 1
	
	FML_IMU_ACC_ODR_104HZ 										= 2,																						//Ƶ - 104					ȼ - 2
	
	FML_IMU_ACC_ODR_208HZ 										= 3,																						//Ƶ - 208					ȼ - 3
	
	FML_IMU_ACC_ODR_416HZ 										= 4,																						//Ƶ - 416					ȼ - 4
	
	FML_IMU_ACC_ODR_833HZ 										= 5,																						//Ƶ - 833					ȼ - 5

} FML_IMU_ACC_ODR_e;

typedef enum{
	FML_IMU_GRY_ODR_OFF   										= 0,																						//ر									ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_GRY_ODR_12HZ5 										= 1,																						//Ƶ - 12.5					ȼ - 1
	
	FML_IMU_GRY_ODR_104HZ 										= 2,																						//Ƶ - 104					ȼ - 2
	
	FML_IMU_GRY_ODR_208HZ 										= 3,																						//Ƶ - 208					ȼ - 3
	
	FML_IMU_GRY_ODR_416HZ 										= 4,																						//Ƶ - 416					ȼ - 4
	
	FML_IMU_GRY_ODR_833HZ 										= 5,																						//Ƶ - 833					ȼ - 5
	
} FML_IMU_GRY_ODR_e;

typedef enum{
	FML_IMU_MAG_ODR_OFF   										= 0,																						//رյشż									ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_MAG_ODR_10HZ 											= 1,																						//Ƶ - 10						ȼ - 1
	
	FML_IMU_MAG_ODR_100HZ 										= 2,																						//Ƶ - 100					ȼ - 2
	
	FML_IMU_MAG_ODR_200HZ											=	3,																						//Ƶ - 200					ȼ - 3
	
} FML_IMU_MAG_ODR_e;

typedef enum{
	FML_IMU_FIFO_ODR_OFF   										= 0,																						//رFIFO										ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_FIFO_ODR_12HZ5 										= 1,																						//Ƶ - 12.5					ȼ - 1
		
	FML_IMU_FIFO_ODR_104HZ 										= 2,																						//Ƶ - 104					ȼ - 2
	
	FML_IMU_FIFO_ODR_208HZ 										= 3,																						//Ƶ - 208					ȼ - 3
	
	FML_IMU_FIFO_ODR_416HZ 										= 4,																						//Ƶ - 416					ȼ - 4
	
	FML_IMU_FIFO_ODR_833HZ 										= 5,																						//Ƶ - 833					ȼ - 5
	
} FML_IMU_FIFO_ODR_e;

typedef enum{
	FML_IMU_ACC_POWER_MODE_HIGH_PERFORMANCE		=	0,																						//ٶȹģʽ - 			ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_ACC_POWER_MODE_NORMAL							=	1,																						//ٶȹģʽ - 				ȼ - 1
	
} FML_IMU_ACC_POWER_MODE_e;

typedef enum{
	FML_IMU_GRY_POWER_MODE_HIGH_PERFORMANCE		=	0,																						//ǹģʽ - 			ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_GRY_POWER_MODE_NORMAL							=	1,																						//ǹģʽ - 				ȼ - 1
	
} FML_IMU_GRY_POWER_MODE_e;

typedef enum{
	FML_IMU_TIMESTAMP_6MS4										=	0,																						//ʱ - 6.4				ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_TIMESTAMP_25US										=	1,																						//ʱ - 25΢					ȼ - 1
	
} FML_IMU_TIMESTAMP_RESOLUTION_e;

typedef enum{
	FML_IMU_TIMESTAMP_OFF											=	0,																						//ʱر									ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_TIMESTAMP_ON											=	1,																						//ʱ									ȼ - 1
	
} FML_IMU_TIMESTAMP_SWITCH_e;

typedef enum{
	FML_IMU_ACC_FS_2G													=	0,																						// - 2ٶ				ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_ACC_FS_16G   											= 1,																						// - 16ٶ				ȼ - 1
	
} FML_IMU_ACC_FS_e;

typedef enum{
	FML_IMU_GRY_FS_250DPS											=	0,																						// - 250ٶ/					ȼ - 0				ȼԽ󣬼Խ
	
	FML_IMU_GRY_FS_2000DPS	  								= 1,																						// - 2000ٶ/				ȼ - 1
	
} FML_IMU_GRY_FS_e;

typedef enum{
	FML_IMU_MAG_FS_30GS   										= 0,																						// - 30˹								ȼ - 0				ȼԽ󣬼Խ
	
} FML_IMU_MAG_FS_e;

typedef enum{
	FML_IMU_DIR_FRONT													=	0,																						// - ǰ
	
	FML_IMU_DIR_BACK													= 1,																						// - 
	
	FML_IMU_DIR_NUM														=	2,																						// - 
	
} FML_IMU_DIR_e;

typedef struct 
{
	FML_IMU_ACC_POWER_MODE_e									acc_power_mode;																	//ٶȹģʽ
	
	FML_IMU_GRY_POWER_MODE_e									gry_power_mode;																	//ǹģʽ
	
	FML_IMU_FIFO_ODR_e												fifo_odr;																				//FIFOƵ
	
	FML_IMU_TIMESTAMP_RESOLUTION_e						timestamp_resolution;														//ʱ
	
	FML_IMU_TIMESTAMP_SWITCH_e								timestamp_switch;																//ʱأעʱʺFIFOһ	
	
	FML_IMU_ACC_ODR_e													acc_odr;																				//ٶȲƵ
	
	FML_IMU_GRY_ODR_e													gry_odr;																				//ǲƵ
	
	FML_IMU_MAG_ODR_e													mag_odr;																				//شżƲƵ
	
	FML_IMU_ACC_FS_e													acc_fs;																					//ٶ
	
	FML_IMU_GRY_FS_e													gry_fs;																					//
	
	FML_IMU_MAG_FS_e													mag_fs;																					//شż
	
} fml_imu_param_t;

typedef struct
{
	int16_t 																	acc[3];																					//ٶ
		
	int16_t 																	gry[3];																					//
	
  int16_t 																	mag[3];																					//شż
	
	int32_t 																	fifo_timestamp;																	//fifoʱ
	
} fml_imu_data_t;

typedef void (*fml_imu_config_cb)(uint32_t conf_result);

typedef void (*fml_imu_data_notify_cb)(uint32_t dir_bit);

/*API -------------------------------------------------------*/
/**
	@brief 		ʼIMUģ
	@param 		
	@return 						- [out]	-1ʧܣ0ɹ
*/
int	fml_imu_Init(void);
/**
	@brief 		ҪIMUĲ
	@param 		param 						- [in]	IMUĲ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int fml_imu_config_param(FML_IMU_DIR_e dir, const fml_imu_param_t *param);
/**
	@brief 		עIMUýص
	@param 		cb 								- [in]	ص
	@return 						- [out]	-1ʧܣ0ɹ
*/
int fml_imu_register_config_callback(fml_imu_config_cb cb);
/**
	@brief 		עIMU֪ͨص
	@param 		cb 								- [in]	ص
	@return 						- [out]	-1ʧܣ0ɹ
*/
int fml_imu_register_data_notify_callback(fml_imu_data_notify_cb cb);
/**
	@brief 		ʼIMU
	@param 		param 						
	@return 	״̬		- [out] -1Ҫã0Ҫ
*/
int fml_imu_start_config(void);
/**
	@brief 		ȡǰIMUݵ
	@param 		dir 							- [in]	
	@return 	صǰIMUݵ
*/
int fml_imu_get_data_num(FML_IMU_DIR_e dir);
/**
	@brief 		ȡǰIMU
	@param 		dir 							- [in]	
	@param 		index 						- [in]	
	@param 		pdata 						- [out]	صIMUָ
	@return 						- [out]	-1ʧܣ0ɹ
*/
int fml_imu_get_data(FML_IMU_DIR_e dir, int index, fml_imu_data_t *pdata);
/**
	@brief 		رIMU
	@param 		dir 							- [in]	
	@return 						- [out]	-1ʧܣ0ɹ
*/
int fml_imu_close(FML_IMU_DIR_e dir);

#ifdef __cplusplus
}
#endif

#endif








