#ifndef __hal_ble_uart0__
#define __hal_ble_uart0__
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"

#ifdef __cplusplus  
extern "C" {  
#endif  

	
#ifdef __cplusplus
} 
#endif

#define UART0_INVALID_PIN		PIN_UART0_UNUSED_PIN		//Ųʹ0XFF

/***************  ********************/
typedef enum {
	UART0_T_HEART = 0,
	UART0_T_CONFIG_ASK,					//
	UART0_T_CONFIG_ACK,					//Գɹ
	UART0_T_CHAR_VOL,						//
	UART0_T_SELF_CHECK_RDY,			//Լ׼
	UART0_T_SELF_CHECK_ASK,			//Լ쿪ʼ
	UART0_T_SELF_CHECK_ACK,			//Լ
	UART0_T_LINE_CHECK_ASK,			//Լ촮ASK
	UART0_T_LINE_CHECK_ACK,			//Լ촮ACK
	UART0_NUM_OF_T,	//ôֵ
}UART0_T_n;	
//#define UART0_NUM_OF_T 9  //ע⣺ֵı

/***************  ********************/
//enum { //UART0_T_UPDATE
//	UART0_T_UPDATE_BASEINFO = 0,	//豸Ϣ
//	UART0_T_UPDATE_DATA ,			//豸
//	UART0_T_UPDATE_STEPNUM ,		//ظ洢
//	UART0_T_UPDATE_STEPNUM_CLERA,	//ɾ洢
//};

//enum { //UART0_T_CHARGE
//	UART0_T_CHARGE_NONE = 0,
//	UART0_T_CHARGE_PULLOUT,
//	UART0_T_CHARGE_INSERT,
//	UART0_T_CHARGE_DONE,
//	UART0_T_CHARGE_ERROR,
//};


/***************  ********************/
typedef enum {
	UART0_R_HEART = 0,
	UART0_R_CONFIG_ASK,					//
	UART0_R_CONFIG_ACK,					//Գɹ
	UART0_R_CHAR_VOL,						//
	UART0_R_SELF_CHECK_RDY,			//Լ׼
	UART0_R_SELF_CHECK_ASK,			//Լ쿪ʼ
	UART0_R_SELF_CHECK_ACK,			//Լ
	UART0_R_LINE_CHECK_ASK,			//Լ촮ASK
	UART0_R_LINE_CHECK_ACK,			//Լ촮ACK
	UART0_NUM_OF_R,	//ôֵ
}UART0_R_n;	
//#define UART0_NUM_OF_R 11  //ע⣺ֵı


/***************  ********************/
//enum { //UART0_R_UPDATE
//	UART0_R_UPDATE_BASEINFO = 0,
//	UART0_R_UPDATE_DATA ,
//	UART0_R_UPDATE_STEPNUM,
//	UART0_R_UPDATE_STEPNUM_CLERA,
//};


typedef void (*UART0_Callback)(void*);

typedef struct _UART0_Rx{
	uint8_t  cmd;
	uint8_t*  pDat;
	uint8_t  datLen;
	UART0_Callback cb;
}UART0_Rx_t;

typedef struct _UART0_Tx{
	uint8_t  n;
	uint32_t t;
	uint8_t  ncnt;
	uint32_t tcnt;
	uint8_t  cmd;
	uint8_t* pDat;
	uint8_t  datLen;
	uint8_t  holdon;
	UART0_Callback cb;
	struct _UART0_Tx *next;	//
}UART0_Tx_t;

void UART0_Initialize(uint32_t txd, uint32_t rxd, uint32_t baud);
void UART0_unInit(uint32_t txd, uint32_t rxd);
void UART0_Send(unsigned char cmd,unsigned char *pDat,unsigned char datLen);
int UART0_Rx_Regist(unsigned char cmd,UART0_Callback cb);
void UART0_Tx_Send(UART0_Tx_t* handle,unsigned char cmd,unsigned char *pDat,unsigned char datLen);
void UART0_Tx_Clear(UART0_Tx_t* handle);
void UART0_Push(unsigned char* p,int len);
void UART0_GetPinConfig(uint32_t *txd, uint32_t *rxd);
void UART0_PrintfDebug(char *p);

#endif

