#ifndef __system_h__
#define __system_h__
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include "sdk_common.h"
#include "SEGGER_RTT.h"
#include "usr_config.h"

#define		PROCESS_REPORT_TASK_USETIME_IMU_FIFO_OVER_NUM				1
#define		PROCESS_REPORT_TASK_USETIME_IMU_FIFO_OVERFLOW				2

typedef void (*Sleep_cb)(uint32_t);
typedef void (*PROCESS_cb)(void);
typedef struct _PROCESS{	//̽ṹ
	uint8_t  holdon;		//Ƿɽ͹ģʽ
	uint16_t Peroid;    //
	uint32_t tim;       //ʱ
	PROCESS_cb cb;			//̺
	uint8_t enable;     //б־λ 	
	#if ProcessTime_EN
	const char    *name; //
	uint32_t useTime;  //ĵʱ
	#endif
}PROCESS_t;

#if DEBUGLOG_ENABLE
#define DEBUG_LOG(format,...) SEGGER_RTT_printf(0,format, ##__VA_ARGS__);
#else 
#define DEBUG_LOG(format,...) 
#endif

int Sleep_Regist(Sleep_cb cb);			//֮ǰĻصע
int Wakeup_Regist(Sleep_cb cb);			//Ļصע
void Sleep_Event(void);
int Process_Start(uint16_t peroid,const char *name,PROCESS_cb cb);	  //app̿ʼ
void Process_Stop(PROCESS_cb cb);	  //appֹͣ
void Process_SetHoldOn(PROCESS_cb cb,uint8_t holdon); //appǷɽ͹ģʽ
void Process_UpdatePeroid(PROCESS_cb cb,uint16_t Peroid);
uint16_t Process_GetPeroid(PROCESS_cb cb);

void Process_report_task_useTime(int report_task_useTime_code);	//ϱһ֡ǰ֡ĺʱIDΪʵʱԵԭԲ֤Է͡
#endif

